%bcond_without cec
%define oname xbmc
%define codename Krypton

Summary:	Kodi (ex-XBMC) Media Center - media player and home entertainment system
Name:		kodi
Version:	17.6
Release:	3
# nosefart audio plugin and RSXS-0.9 based screensavers are GPLv2 only
# several eventclients are GPLv3+ (in subpackages)
# libhdhomerun is LGPLv3+ with an exception (always ok to link against it)
# the rest is GPLv2+
# both GPLv2+ and GPLv2 are mentioned because plugins are not part of core
# xbmc and therefore e.g. /usr/bin/xbmc is GPLv2+ with LGPLv3+ part
# as allowed by a license exception
License:	GPLv2+ and GPLv2 and (LGPLv3+ with exceptions)
Group:		Video
Url:		http://kodi.tv/
Source0:	http://mirrors.kodi.tv/releases/source/%{version}-%{codename}.tar.gz
Source10:	libdvdcss-2f12236bc1c92f73c21e973363f79eb300de603f.tar.gz
Source11:	libdvdnav-43b5f81f5fe30bceae3b7cecf2b0ca57fc930dac.tar.gz
Source12:	libdvdread-17d99db97e7b8f23077b342369d3c22a6250affd.tar.gz

Patch1:		xbmc-17.0-no-win32.patch
# Display Music Videos in "Artist - Name" format instead of just "Name"
Patch2:		xbmc-17.0-upnp-musicvideos-artist.patch
# Fix bug with UPnP playback for Playlists
Patch3:		xbmc-14.1-upnp-playlists.patch
Patch4:		xbmc-16.0-session.patch
# Seems to create dlopen call loop and crash so disable it
Patch5:		xbmc-14.2-no-dlopen-wrapper.patch
Patch6:		xbmc-17.1-desktop.patch
Patch7:		xbmc-17.0-external-libs-versions.patch
# http://bugs.rosalinux.ru/show_bug.cgi?id=8887
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=881536
Patch8:		xbmc-17.6-fix-audio-with-latest-ffmpeg.patch

BuildRequires:	avahi-common-devel
BuildRequires:	boost-devel
BuildRequires:	bzip2-devel
BuildRequires:	crossguid-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	gettext-devel
BuildRequires:	giflib-devel
BuildRequires:	jpeg-devel
BuildRequires:	liblzo-devel
BuildRequires:	mysql-devel
BuildRequires:	tinyxml-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(avahi-client)
BuildRequires:	pkgconfig(bluez)
BuildRequires:	pkgconfig(cwiid)
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(dcadec)
BuildRequires:	pkgconfig(egl)
BuildRequires:	pkgconfig(enca)
BuildRequires:	pkgconfig(expat)
BuildRequires:	pkgconfig(flac)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(fribidi)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glew)
BuildRequires:	pkgconfig(glu)
BuildRequires:	pkgconfig(ice)
BuildRequires:	pkgconfig(jasper)
BuildRequires:	pkgconfig(libass)
BuildRequires:	pkgconfig(libbluray)
BuildRequires:	pkgconfig(libcdio)
%if %{with cec}
BuildRequires:	pkgconfig(libcec)
%endif
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(libmicrohttpd)
BuildRequires:	pkgconfig(libmms)
BuildRequires:	pkgconfig(libmpeg2)
BuildRequires:	pkgconfig(libnfs)
BuildRequires:	pkgconfig(libpcre)
BuildRequires:	pkgconfig(libplist)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(librtmp)
# libshairplay should be used now but there's no stable release yet
# BuildRequires:	pkgconfig(libshairport)
BuildRequires:	pkgconfig(libssh)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libusb-1.0)
BuildRequires:	pkgconfig(libva)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(mad)
BuildRequires:	pkgconfig(ogg)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(python)
BuildRequires:	pkgconfig(samplerate)
BuildRequires:	pkgconfig(sdl2)
BuildRequires:	pkgconfig(SDL2_mixer)
BuildRequires:	pkgconfig(SDL2_image)
# Doesn't seem to use it for anything but configure checks
BuildRequires:	pkgconfig(SDL_image)
BuildRequires:	pkgconfig(smbclient)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(taglib)
BuildRequires:	pkgconfig(udev)
BuildRequires:	pkgconfig(vdpau)
BuildRequires:	pkgconfig(vorbis)
BuildRequires:	pkgconfig(wavpack)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xmu)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xt)
BuildRequires:	pkgconfig(xtst)
BuildRequires:	pkgconfig(yajl)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	cmake
BuildRequires:	gperf
BuildRequires:	zip
%ifarch %{ix86}
BuildRequires:	nasm
%endif
Requires:	lsb-release
# for codegenrator
BuildRequires:	doxygen
BuildRequires:	java
BuildRequires:	java-devel
BuildRequires:	swig

# dlopened (existence check required by rpm5 as it doesn't use stderr):
%define dlopenreq() %([ -e %{_libdir}/lib%{1}.so ] && rpm -qf --qf '%%{name}' $(readlink -f %{_libdir}/lib%{1}.so) 2>/dev/null || echo %{name})
Requires:	%dlopenreq curl
Requires:	%dlopenreq FLAC
Requires:	%dlopenreq mad
Requires:	%dlopenreq ogg
Requires:	%dlopenreq vorbis
Requires:	%dlopenreq vorbisenc
Requires:	%dlopenreq vorbisfile
Requires:	%dlopenreq rtmp
Requires:	%dlopenreq mpeg2
Requires:	%dlopenreq ass
Requires:	%dlopenreq bluray
Requires:	%dlopenreq nfs
Requires:	%dlopenreq plist
%if %{with cec}
Requires:	%dlopenreq cec
%endif
# not nearly as common as the above, so just suggest instead for now:
Suggests:	%dlopenreq crystalhd
# TODO: FEH.py is useless nowadays, drop it here and upstream.
# for FEH.py, to check current configuration is ok for xbmc:
Requires:	xdpyinfo
Requires:	glxinfo
# for FEH.py to allow it to give an error message (should be available already
# on most systems):
Requires:	pygtk2
# for xbmc python scripts:
Requires:	python-imaging
# Packages not shipped in core:
Suggests:	%{_lib}lame0
Suggests:	%{_lib}dvdcss2

Provides:	%{oname} = %{EVRD}
Conflicts:	%{oname} < 0.17
Obsoletes:	%{oname} < 0.17

%description
Kodi (ex-XBMC) is an award-winning free and open source software media
player and entertainment hub for digital media.

While Kodi functions very well as a standard media player application
for your computer, it has been designed to be the perfect companion
for your HTPC. Supporting an almost endless range of remote controls,
and combined with its beautiful interface and powerful skinning
engine, Kodi feels very natural to use from the couch and is the
ideal solution for your home theater.

Support for RAR files is not included due to license issues.

%files
%doc %{_docdir}/kodi
%{_bindir}/xbmc
%{_bindir}/xbmc-standalone
%{_bindir}/kodi
%{_bindir}/kodi-standalone
%dir %{_libdir}/kodi
%dir %{_libdir}/kodi/addons
%dir %{_libdir}/kodi/system
%dir %{_libdir}/kodi/system/players
%dir %{_libdir}/kodi/system/players/VideoPlayer
%{_libdir}/kodi/kodi.bin
%{_libdir}/kodi/kodi-xrandr
%dir %{_libdir}/kodi/addons/*
%{_libdir}/kodi/addons/*/*.so
%{_libdir}/kodi/system/libcpluff-*.so
%{_libdir}/kodi/system/libexif-*.so
%optional %{_libdir}/kodi/system/libsse4-*.so
%{_libdir}/kodi/system/players/VideoPlayer/libdvdcss-*.so
%{_libdir}/kodi/system/players/VideoPlayer/libdvdnav-*.so
%dir %{_datadir}/kodi
%{_datadir}/kodi/addons
%{_datadir}/kodi/media
%{_datadir}/kodi/system
%{_datadir}/kodi/userdata
%{_datadir}/kodi/privacy-policy.txt
%{_datadir}/xsessions/kodi.desktop
%{_datadir}/applications/kodi.desktop
%{_iconsdir}/hicolor/*/apps/kodi.png

#----------------------------------------------------------------------------

%package devel
Summary:	Development files for Kodi (ex-XBMC)
License:	GPLv2+
Group:		Development/C
Provides:	%{oname}-devel = %{EVRD}
Provides:	xbmc-eventclients-devel = %{EVRD}
Conflicts:	xbmc-eventclients-devel < 13.0
Obsoletes:	xbmc-eventclients-devel < 13.0
Conflicts:	%{oname}-devel < 0.17
Obsoletes:	%{oname}-devel < 0.17

%description devel
Kodi (ex-XBMC) is an award-winning free and open source software media player
and entertainment hub for digital media.

This package contains files needed to build addons and eventclients.

%files devel
%dir %{_includedir}/kodi
%{_includedir}/kodi/*
%{_libdir}/kodi/*.cmake

#----------------------------------------------------------------------------

%package eventclients-common
Summary:	Common files for Kodi (ex-XBMC) eventclients
License:	GPLv2+
Group:		Video
Conflicts:	%{oname}-eventclients-common < 0.17
Obsoletes:	%{oname}-eventclients-common < 0.17
Obsoletes:	%{oname}-eventclient-j2me < 0.17

%description eventclients-common
Kodi (ex-XBMC) is an award-winning free and open source software media player
and entertainment hub for digital media.

This package contains common files for eventclients.

%files eventclients-common
%{python_sitelib}/kodi
%dir %{_datadir}/pixmaps/kodi
%{_datadir}/pixmaps/kodi/*.png

#----------------------------------------------------------------------------

%package eventclient-wiiremote
Summary:	Wii Remote eventclient for Kodi (ex-XBMC)
License:	GPLv3+
Group:		Video
Requires:	%{name}-eventclients-common = %{EVRD}
Conflicts:	%{oname}-eventclient-wiiremote < 0.17
Obsoletes:	%{oname}-eventclient-wiiremote < 0.17

%description eventclient-wiiremote
Kodi (ex-XBMC) is an award-winning free and open source software media player
and entertainment hub for digital media.

This package contains the Wii Remote eventclient.

%files eventclient-wiiremote
%{_bindir}/kodi-wiiremote

#----------------------------------------------------------------------------

%package eventclient-ps3
Summary:	PS3 eventclients for Kodi (ex-XBMC)
License:	GPLv2+
Group:		Video
Requires:	python-pybluez
Requires:	%{name}-eventclients-common = %{EVRD}
# requires via zeroconf.py, only used by xbmc-ps3d:
Requires:	avahi-python
Requires:	python-dbus
Requires:	python-gobject
Conflicts:	%{oname}-eventclient-ps3 < 0.17
Obsoletes:	%{oname}-eventclient-ps3 < 0.17

%description eventclient-ps3
Kodi (ex-XBMC) is an award-winning free and open source software media player
and entertainment hub for digital media.

This package contains the PS3 remote and sixaxis eventclients.

%files eventclient-ps3
%{_bindir}/kodi-ps3d
%{_bindir}/kodi-ps3remote

#----------------------------------------------------------------------------

%package eventclient-xbmc-send
Summary:	PS3 eventclient for Kodi (ex-XBMC)
License:	GPLv2+
Group:		Video
Requires:	%{name}-eventclients-common = %{EVRD}
Conflicts:	%{oname}-eventclient-xbmc-send < 0.17
Obsoletes:	%{oname}-eventclient-xbmc-send < 0.17

%description eventclient-xbmc-send
Kodi (ex-XBMC) is an award-winning free and open source software media player
and entertainment hub for digital media.

This package contains the xbmc-send eventclient.

%files eventclient-xbmc-send
%{_bindir}/kodi-send

#----------------------------------------------------------------------------

%prep
%setup -qn %{oname}-%{version}-%{codename}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

cp %{SOURCE10} tools/depends/target/libdvdcss/
cp %{SOURCE11} tools/depends/target/libdvdnav/
cp %{SOURCE12} tools/depends/target/libdvdread/

# otherwise backups end up in binary rpms
find -type f \( -name '*.00??' -o -name '*.00??~' \) -print -delete

# remove prebuilt libraries
find -type f \( -iname '*.so' -o -iname '*.dll' -o -iname '*.exe' \) -delete

# win32 only
rm -rf system/players/dvdplayer/etc/fonts

%build
export GIT_REV="tarball"
./bootstrap

# due to xbmc modules that use symbols from xbmc binary
# and are not using libtool
%define _disable_ld_no_undefined 1

# Workaround configure using git to override GIT_REV (TODO: fix it properly)
export ac_cv_prog_HAVE_GIT="n"

%configure2_5x \
	--disable-debug \
	--disable-ccache \
	--with-ffmpeg=shared \
%ifarch %{arm}
	--enable-neon \
%endif
	--disable-non-free \
%if %{with cec}
	--enable-libcec \
%else
	--disable-libcec \
%endif
	--enable-pulse \
	--with-lirc-device=/var/run/lirc/lircd

# non-free = unrar
# dvdcss is handled via dlopen when disabled

%make
%make -C tools/EventClients wiimote

%install
%makeinstall_std
%makeinstall_std -C tools/EventClients

# remove compat directory symlinks (RPM cannot handle dir=>symlink transition so
# more complex handling would be needed for these)
rm -f %{buildroot}%{_datadir}/xbmc
rm -f %{buildroot}%{_includedir}/xbmc
rm -f %{buildroot}%{_libdir}/xbmc
# remove duplicate symlink
rm -f %{buildroot}%{_datadir}/xsessions/xbmc.desktop

( # for IFS and +x
# Check for issues in ELF binaries
undefined=
fhserr=
echo Silencing output of undefined symbol and FHS conformance checks
set +x
IFS=$'\n'
for file in $(find %{buildroot} -type f); do
	type="$(file "$file")"
	echo "$type" | grep -q "ELF" || continue

	# Check that a binary file is not in datadir:
	echo "$file" | grep -q "%{_datadir}" && fhserr="${fhserr}$file\n"

	# check for undefined symbols in XBMC modules
	echo "$type" | grep -q "shared object" || continue
	for symbol in $(LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{buildroot}%{_libdir} ldd -r "$file" 2>&1 | grep undefined | awk '{ print $3 }'); do
		# undefined symbols may also be provided by XBMC:
		nm -f posix -D --no-demangle --defined-only %{buildroot}%{_libdir}/kodi/kodi.bin | grep -q "^$symbol " && continue
		# The symbol was not provided by XBMC.
		# Check if it is available through its dependencies:
		for filename in $(objdump -p %{buildroot}%{_libdir}/kodi/kodi.bin | grep NEEDED | awk '{ print $2 }'); do
			depfile="/%{_lib}/$filename"
			[ -e "$depfile" ] || depfile="%{_libdir}/$filename"
			nm -f posix -D --no-demangle --defined-only $depfile | grep -q "^$symbol " && continue 2
		done
		# Euphoria references rsxs PNG class, but it is never used at runtime,
		# so it results in no errors due to RTLD_LAZY being used by XBMC module loader.
		case $file:$symbol in */Euphoria.xbs:_ZN3PNG*) continue; esac
		# the symbol was not found
		undefined="${undefined}$file: $symbol\n"
	done
done
ok=1
[ -n "$undefined" ] && echo -e "$undefined" && echo "Undefined symbols!" && ok=
[ -n "$fhserr" ] && echo -e "$fhserr" && echo "Binaries in datadir!" && ok=
[ -n "$ok" ]
)


%changelog
